pragma solidity >=0.4.9 <0.7; // ^0.5.7;

contract bet { 
   address payable owner;

   struct ABet {
        address payable betAddress;
        uint    betAmount;
        uint    betTip;
   }

   ABet[] bets;

   constructor() public {
        owner = msg.sender;
   }

   modifier onlyOwner() {
      require(
            msg.sender == owner, 
            "Only the owner can do this." // Dont know how to get this error message.
            );
            _;
   }
   
   event betted(address from, uint amount_ether, uint tip);
   event payed(address to, uint amount_ether);
   event lost(address who, uint amount_ether);

   function makeBet(uint _tip) public payable {
       if ( msg.value > 0 ) {
          uint n = bets.length++;
          bets[n].betAddress = msg.sender;
          bets[n].betAmount = msg.value;
          bets[n].betTip = _tip;
          emit betted( msg.sender, msg.value, _tip);
          }
   }

   function closeBet(uint _ctip) onlyOwner public {
      uint winstake = 0;
      for (uint i = 0; i < bets.length; ++i) {
          if ( bets[i].betTip == _ctip ) {
              winstake = winstake + bets[i].betAmount;
          } else {
              uint x = bets[i].betAmount;
              bets[i].betAmount = 0;
              emit lost(bets[i].betAddress, x);
          }
      }
      if ( winstake == 0 ) {
          cancel();
      } else {
         uint winfactor100 = address(this).balance * 100 / winstake;
         uint rest = address(this).balance;
         for (uint i = 0; i < bets.length; ++i) {
             if ( bets[i].betAmount != 0 ) {
                uint x = bets[i].betAmount * winfactor100 / 100;
                bets[i].betAddress.transfer( x );
                rest = rest - x;
                emit payed(bets[i].betAddress, x);
             }
         }
         if ( rest > 0 ) {
             owner.transfer(rest);
             emit payed(owner, rest);
         }
         bets.length = 0;
      }
   }

  function cancel() public onlyOwner {
      for (uint i = 0; i < bets.length; ++i) {
              uint x = bets[i].betAmount;
              bets[i].betAmount = 0;
              bets[i].betAddress.transfer( x );
              // emit ls("paid", bets[i].betAddress, x, 0);
              emit payed(bets[i].betAddress, x);
      }
      bets.length = 0;
  }

    function kill() public onlyOwner { 
      cancel();
      selfdestruct(owner); 
  }

}

