
// p("depot.util.js loading");

//----------------------------                   //
function depotBal() {                            // Balance of the depot, i.e. eth.getBalance(depot.address)
  if ( depot != null ) {
     p("eth.getBalance(" + depot.address + ") is " + web3.fromWei(eth.getBalance(depot.address),"ether") + " ether" );
  }
}

//----------------------------                   //
function depotUsed() {                           // Whether the depot is free or in use.
  p("depot.used()")
  if ( depot != null ) {
     if ( depot.used() ){
        p("depot is occupied");
     } else {
        p("depot is free");
     }
  }
}

//----------------------------                   //
function depotSendi(f,t,a,unit) {                // Send (internal) from f (local) to t (local)
  if ( depot != null && gasDefined() && eth.getCode(depot.address) != "0x" ) {
       p("ts = depot.send.sendTransaction(eth.accounts[t],{from:eth.accounts[f], value: web3.toWei(a,unit), gas: '4700000', gasPrice: web3.toWei(gasPriceToPay,'gwei')})");
          ts = depot.send.sendTransaction(eth.accounts[t],{from:eth.accounts[f], value: web3.toWei(a,unit), gas: '4700000', gasPrice: web3.toWei(gasPriceToPay,'gwei')});
       p("Transaction sent. tx: " + ts);
  }
}

//----------------------------                   //
function depotSend(f,toaddr,a,unit) {            // Send from f (local) to toaddr (an address)
  if ( depot != null && gasDefined() && eth.getCode(depot.address) != "0x" ) {
       p("ts = depot.send.sendTransaction(toaddr,{from:eth.accounts[f], value: web3.toWei(a,unit), gas: '4700000', gasPrice: web3.toWei(gasPriceToPay,'gwei')})");
          ts = depot.send.sendTransaction(toaddr,{from:eth.accounts[f], value: web3.toWei(a,unit), gas: '4700000', gasPrice: web3.toWei(gasPriceToPay,'gwei')});
       p("Transaction sent. tx: " + ts);
  }
}

//----------------------------                   //
function depotPay() {                            // Conclude the payment
  if ( depot != null && gasDefined() && eth.getCode(depot.address) != "0x" ) {
       p("ts = depot.pay.sendTransaction({from:eth.accounts[0], gas: '4700000', gasPrice: web3.toWei(gasPriceToPay,'gwei')})");
          ts = depot.pay.sendTransaction({from:eth.accounts[0], gas: '4700000', gasPrice: web3.toWei(gasPriceToPay,'gwei')})
       p("Transaction sent. tx: " + ts);
  }
}

//----------------------------                   //
function depotUnpay() {                          // Revert the payment
  if ( depot != null && gasDefined() && eth.getCode(depot.address) != "0x" ) {
       p("ts = depot.unpay.sendTransaction({from:eth.accounts[0], gas: '4700000', gasPrice: web3.toWei(gasPriceToPay,'gwei')})");
          ts = depot.unpay.sendTransaction({from:eth.accounts[0], gas: '4700000', gasPrice: web3.toWei(gasPriceToPay,'gwei')})
       p("Transaction sent. tx: " + ts);
  }
}

//----------------------------                   //
function depotKill() {                           // Kill the depot smart contract
  if ( depot != null && gasDefined() ) {
       p("ts = depot.kill.sendTransaction({from:eth.accounts[0], gas: '4700000', gasPrice: web3.toWei(gasPriceToPay,'gwei')})");
          ts = depot.kill.sendTransaction({from:eth.accounts[0], gas: '4700000', gasPrice: web3.toWei(gasPriceToPay,'gwei')})
       p("Transaction sent. tx: " + ts);
  }
}


//  Eventcode for event sent(address from, address to, uint amount_ether); - to override define
function depotEvent_sent( from , to , amount_ether ) {
    console.log( "vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv" );
    console.log( "MY depot:sent:"
     + " from: " + from  + " to: " + to  + " amount: " + web3.fromWei(amount_ether,"ether") + " ether"
    );
    console.log( "^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^" );
}

//  Generating Eventcode for event rejected(address from, address to, uint amount_ether); - to override define
// function depotEvent_rejected( from , to , amount_ether ) {
// }


//  Eventcode for event payed(address from, address to, uint amount_ether); - to override define
// function depotEvent_payed( from , to , amount_ether ) {
// }

//  Eventcode for event unpayed(address from, address to, uint amount_ether); - to override define
// function depotEvent_unpayed( from , to , amount_ether ) {
// }

//  Generating Eventcode for event killed(address who); - to override define
// depotEvent_killed( who ) {
// }
